**************
* WindowsBar *
**************
*
* Description:
*    ToolBar,     
*     VFP
*    ( Windows' TaskBar).
*
* Functions:
*    Click on Button -  ;
*    RightClick on Button -  ;
*    RightClick on ToolBar -   
*       (  "Ctrl+Alt+Shift")
*           -  
*           .
*
* HowToUse:
*     Tools / Options...
*     File Locations
*     Startup Program
*     "\WindowsBar.prg"
*     Set As Default
*     FoxPro
*
*********************
* Created by        *
* ChAO              *
* ( )   *
* mailto:chao@nm.ru *
* October 2002      *
*********************

PUBLIC oWindowsBar
oWindowsBar=CREATEOBJECT("WindowsBar")
oWindowsBar.SHOW
oWindowsBar.DOCK(3)

DEFINE CLASS WindowsBar AS TOOLBAR
	DIMENSION aWins[1000]	&&   
	wCount=0	&&  
	oActive=NULL	&&  
	cFontName = 'MS Sans Serif'
	nFontSize = 8
	cFontStyle = 'B'
	AvgWidth=0

	PROCEDURE INIT
		THIS.AvgWidth=FONTMETRIC(6,THIS.cFontName,THIS.nFontSize,THIS.cFontStyle)
	ENDPROC

	PROCEDURE MOUSEDOWN
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		DO CASE
		CASE nButton=2	&&  .
			*   "Ctrl+Alt+Shift"
			DECLARE INTEGER keybd_event IN win32api INTEGER, INTEGER, INTEGER, LONG
			keybd_event(16,0,0,0)
			keybd_event(17,0,0,0)
			keybd_event(18,0,0,0)
			WAIT ''
			keybd_event(16,0,2,0)
			keybd_event(17,0,2,0)
			keybd_event(18,0,2,0)
			IF !ISNULL(THIS.oActive)
				THIS.ActWin(THIS.oActive)
			ENDIF
		ENDCASE
	ENDPROC

	PROCEDURE DelWin	&&  
		LPARAMETERS cName
		IF WEXIST(cName)
			RELEASE WINDOW (cName)
		ENDIF
		THIS.rebuild
	ENDPROC

	PROCEDURE ActWin	&&  
		LPARAMETERS oBut
		IF EMPTY(oBut.wName)
			THIS.rebuild
			RETURN
		ENDIF
		IF !ISNULL(THIS.oActive)
			THIS.oActive.VALUE=0
		ENDIF
		THIS.oActive=oBut
		IF WEXIST(oBut.wName)
			oBut.VALUE=1
			ACTIVATE WINDOW (oBut.wName)
		ENDIF
	ENDPROC

	PROCEDURE rebuild	&&  
		LOCAL i,nCount,aW,cWin,cOldExactSet
		WITH THIS
			nCount=WCHILD('SCREEN')
			DIMENSION aW(nCount+1)
			FOR i=0 TO nCount-1
				cWin=WCHILD('SCREEN',i)
				IF EMPTY(cWin) OR !WVISIBLE(cWin)
					nCount=nCount-1
				ELSE
					aW[i+1]=cWin
				ENDIF
			ENDFOR
			FOR i=nCount+2 TO .CONTROLCOUNT
				IF .CONTROLS(i).VISIBLE
					.CONTROLS(i).VISIBLE=.F.
				ENDIF
			ENDFOR
			IF .CONTROLCOUNT-1<nCount	&&    
				FOR i=.CONTROLCOUNT TO nCount
					.ADDOBJECT('WB_button'+ALLTRIM(STR(i)),'WB_button')
				ENDFOR
			ENDIF
			FOR i=1 TO .wCount	&&   
				lFlag=.F.
				FOR j=1 TO nCount
					IF TYPE('.aWins[i]')='C' AND TYPE('aW[j]')='C' AND aW[j]==.aWins[i]
						lFlag=.T.
						EXIT
					ENDIF
				ENDFOR
				IF !lFlag
					ADEL(.aWins,i)
					.wCount=.wCount-1
				ENDIF
			ENDFOR
			FOR i=1 TO nCount	&&   
				lFlag=.F.
				FOR j=1 TO .wCount
					IF TYPE('.aWins[j]')='C' AND TYPE('aW[i]')='C' AND aW[i]==.aWins[j]
						lFlag=.T.
						EXIT
					ENDIF
				ENDFOR
				IF !lFlag
					.wCount=.wCount+1
					.aWins[.wCount]=aW[i]
				ENDIF
			ENDFOR
			.wCount=nCount
			FOR i=0 TO .wCount-1	&&   
				.CONTROLS(i+2).INIT(.aWins[i+1])
			ENDFOR
		ENDWITH
	ENDPROC

	ADD OBJECT WB_Timer AS TIMER WITH ;
		WIDTH=0, ;
		HEIGHT=0, ;
		INTERVAL=200, ;
		ENABLED=.T.

	PROCEDURE WB_Timer.TIMER
		LOCAL i,cName,cWin,nActiveWin
		cWin=WONTOP()
		WITH THIS.PARENT
			IF .wCount<>WCHILD('SCREEN')	&&    
				.rebuild
			ENDIF
			IF EMPTY(cWin)	&&   
				IF !ISNULL(.oActive)
					.oActive.VALUE=0
				ENDIF
				RETURN
			ENDIF
			nActiveWin=ASCAN(.aWins,cWin)	&&    
			IF !EMPTY(nActiveWin)	&&  
				IF cWin<>.CONTROLS(nActiveWin+1).wName
					.rebuild
				ENDIF
				IF ISNULL(.oActive) OR cWin<>.oActive.wName OR !.oActive.VISIBLE
					IF !ISNULL(.oActive)
						.oActive.VALUE=0
					ENDIF
					.oActive=.CONTROLS(nActiveWin+1)
				ENDIF
				IF !ISNULL(.oActive)
					.oActive.VALUE=1
				ENDIF
			ELSE	&&      
				.rebuild
			ENDIF
		ENDWITH
	ENDPROC
ENDDEFINE

DEFINE CLASS WB_button AS CHECKBOX
	wName=''	&&  ,    
	STYLE=1
	WIDTH=150
	HEIGHT=20
	ENABLED=.T.

	PROCEDURE INIT
		LPARAMETERS cWin	&&  
		LOCAL cCapt,i,cTitle
		IF EMPTY(cWin)
			THIS.VISIBLE=.F.
			RETURN
		ENDIF
		cTitle=IIF(EMPTY(WTITLE(cWin)),cWin,WTITLE(cWin))
		cCapt=LOWER(cTitle)
		*  ,   
		THIS.FONTNAME=THIS.PARENT.cFontName
		THIS.FONTSIZE=THIS.PARENT.nFontSize
		THIS.FONTBOLD=('B'$THIS.PARENT.cFontStyle)
		THIS.FONTITALIC=('I'$THIS.PARENT.cFontStyle)
		THIS.FONTSTRIKETHRU=('-'$THIS.PARENT.cFontStyle)
		THIS.FONTUNDERLINE=('U'$THIS.PARENT.cFontStyle)
		i=MAX(150,LEN(cCapt))
		DO WHILE TXTWIDTH('...'+RIGHT(cCapt,i),THIS.PARENT.cFontName, THIS.PARENT.nFontSize,THIS.PARENT.cFontStyle)*THIS.PARENT.AvgWidth>THIS.WIDTH-10
			i=i-1
		ENDDO
		IF i<LEN(cCapt)
			THIS.CAPTION='...'+RIGHT(cCapt,i)
			THIS.TOOLTIPTEXT=cTitle
		ELSE
			THIS.CAPTION=cCapt
		ENDIF

		THIS.wName=cWin
		IF !THIS.VISIBLE
			THIS.VISIBLE=.T.
		ENDIF
	ENDPROC

	PROCEDURE INTERACTIVECHANGE
		THIS.PARENT.ActWin(THIS)	&&  
	ENDPROC

	PROCEDURE MOUSEUP
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		DO CASE
		CASE nButton=2	&&   -  
			THIS.PARENT.DelWin(THIS.wName)
		ENDCASE
	ENDPROC
ENDDEFINE
